clear;
close all;
cd('C:/Users/usuari/Dropbox/A UdG/4rt GEEIA/TFG/Acustica/Gravacions/Varis')
% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------  LECTURA  -----------------------------------------------------------------%
% % % % % ------------------------------------------------------------------------------------------%
[xx,fs] = audioread('AudioAccident.wav');  %% 1eraccident
[xx,fs] = audioread('Audio2accident.wav');  %% 2onaccident
[xx,fs] = audioread('Audio3accident.wav');  %% 3erccident
[xx,fs] = audioread ('myth_cut.wav');        %% Musica
% F = importdata('silenci_v3.txt');
% F = importdata('AudioaAccident_v2.txt');% Accident 1
sxx=xx(:,1);
numx=numel(sxx);
L=numx;
Fs = 44100;                             % Fs de l'audio
T = 1/Fs;     
% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------  GRAFIC TEMPORAL  ---------------------------------------------------------%
% % % % % ------------------------------------------------------------------------------------------%
plot(sxx);   % Grfic
% xlim([0 10000]) 
% grid on;
title('So accident');
ylabel('Energia')
xlabel('Temps (1/fs)')
axis tight

% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------  ESPECTRE D'UNA FINESTRA  -------------------------------------------------%
% % % % % ------------------------------------------------------------------------------------------%
sxx=xx(:,1);                                          
iter=0;
finestra=256*1;                         % Mida de la finestra temporal
tempstotal=L*1/Fs;   
tall1=0.734;                            %  Inici finestra
tall2=tall1+0.007;                      %  Fi finestra
tall=tall2/tempstotal;
tall1=tall1/(1/Fs);
i=tall1;
j=finestra+i-1;
NFFT = finestra;
while j<(L*tall)
iter=iter+1;
ssxx=sxx(i:j);
psxx= fft(ssxx,NFFT);                   % FFT
f = linspace(0,1,NFFT/2+1)*Fs/2
AA=abs(psxx(1:NFFT/2+1));               % Amplitutsingleside
AA=(AA.^2)/NFFT;                        % Power spectrum
psxxmatriu(iter,:)=AA;
temps=1000*j*1/Fs;
temps=round(temps);
plot(f,AA)
hgca = gca;
ylabel('Energia')
xlabel('Freqncia (Hz)')
xlim([0 16000]);
i=i+finestra;
j=j+finestra; 
jjj=100;
ttt=1;
end
set(gca,'XTick',0:1000:16000);


% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------  ESPECTRE DE VARIES FINESTRES SUPERPOSADES---------------------------------%
% % % % % ------------------------------------------------------------------------------------------%
iter=0;
finestra=256;
tempstotal=L*1/Fs;   
i=1;
j=i+finestra;
NFFT = 2^nextpow2(j-i) 
while j<(L)
ssxx=sxx(i:j);
psxx= fft(ssxx,NFFT);
f = linspace(0,1,NFFT/2+1)*Fs/2
AA=abs(psxx(1:NFFT/2+1));
AA=(AA.*conj(AA))/NFFT;
plot(f,AA,'.b')
ylabel('Energia')
xlabel('Freqncia (Hz)')
xlim([0 15000]);
hold on;
i=i+finestra;
j=j+finestra;
end
    
% % % % % ------------------------------------------------------------------------------------------%
% % % % % -----------------------------------  ESPECTROGRAMA  --------------------------------------%
% % % % % ------------------------------------------------------------------------------------------%  
segmentLength = round(numel(sxx)/4.5); 
spectrogram(sxx,round(segmentLength/5), ...
round(80/100*segmentLength/5),[],Fs,'yaxis')
ylim([0 11])  
ylabel('Freqncia (Hz)')
xlabel('Temps (s)')

% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------------------  GUARDAR ESPECTRE DEL PATR  ----------------------------------%
% % % % % ------------------------------------------------------------------------------------------%
iter=0;
finestra=256*1;
tempstotal=L*1/Fs;   
tall1=0.734;
tall2=tall1+0.00750;  %256punts
tall=tall2/tempstotal;
tall1=tall1/(1/Fs);
i=tall1;
j=finestra+i-1;
NFFT = 2^nextpow2(j-i) % Next power of 2 from length of y
while j<(L*tall)
iter=iter+1;
AA=sxx(i:j);
ssxx=AA;
temps=1000*j*1/Fs;
temps=round(temps);
psxx= fft(ssxx,NFFT);
f = linspace(0,1,NFFT/2+1)*Fs/2
A=abs(psxx(1:NFFT/2+1));%amplitutsingleside
AA=A; %Vrms
AA=(AA.^2)/NFFT;%Power spectrum
psxxmatriu(iter,:)=AA;
psxxmatriu(iter,(finestra+2))=temps;
save PP734ms_256Ss.txt psxxmatriu -ASCII;   % GRAVAR    
% save PP1916ms_256S.txt psxxmatriu -ASCII;
end

% % % % % ------------------------------------------------------------------------------------------%
% % % % % ------------------------------  MTODES DE SIMILITUD  ------------------------------------%
% % % % % ------------------------------------------------------------------------------------------%

% % % % % --------------------------------  LECTURA  -----------------------------------------------%
[xx,fs1] = audioread('AudioAccident.wav'); arxiutitle='udio Accident'; %%1er accident
[xx,fs1] = audioread('Audio2accident.wav'); button=1;  arxiutitle='udio 2 accident';  
[xx,fs1] = audioread('Audio3accident.wav'); button=1;  arxiutitle='udio Accident'; %%accident
[xx,fs1] = audioread ('myth_cut.wav'); button=1; relaclim=0.0; arxiutitle='udio msica'; 
sxx=xx(1:100000,1);  
sxx=xx(:,1);  
numx=numel(sxx);
Fs = 40000;                    
T = 1/Fs;                     
L = numx;    
% % % % % --------------------------------  LECTURA  PATRONS----------------------------------------%
PP= importdata('PP734ms_256S.txt'); button2=1;  patrotitle='Patr1'; tp1=0.734; f1patro=3; f2patro=8; f3patro=8; f4patro=13;
QQ= importdata('PP734ms_256Ss.txt'); button2=1;  patrotitle='Patr1';tp2=0.734; f1patro=3; f2patro=8; f3patro=8; f4patro=13;
PP = importdata('PP1916ms_256S.txt'); button2=2; patrotitle='Patr2';tp1=1.916; f1patro=1; f2patro=5; f3patro=6; f4patro=10;f5patro=10; f6patro=14;
QQ = importdata('PP1916ms_256Ss.txt'); button2=2; patrotitle='Patr2';tp2=1.916; f1patro=1; f2patro=5; f3patro=6; f4patro=10;f5patro=10; f6patro=14;
PP=PP.';
PPP=PP(1:256,1); 
QQ=QQ.';
QQQ=QQ(1:256,1); 
% % % % % --------------------------------- PARAMETRES MTODES -------------------------------------%
salt=1;                               % Inserir salts entre les finestres
sp=1;                                 % Inserir superposici (contrari de salts)
superposicio1=sp/salt;
superposicio2=sp/salt;
superposicio3=sp/salt;
superposicio4=sp/salt;
finestra=256*1;                       % Mida finestra temporal
nmax1=15;                             % nmax
nmax3=15;                             % nmax
nmig=50;                              % Per el calcul MSC mig i RD mig, agafar nomes frequencies de 0Hz a 
limitmig=0.5;                         % per dibuixar grafic 
button=0;                             % Opci grfic
button2=0;                            % Opci d'anivellament
relaclim=0.6;                         % nlimit
relaclim2=0.3;                        % nlimit2
%..............................................................................................................

% % % % % ---------------------------- 1- MSC EQUIVALENT  ------------------------------------------%
tempstotal=L*((1/fs1));
iter=0;
i=1;
j=finestra+i-1;
NFFT = 2^nextpow2(j-i); % Next power of 2 from length of y
while j<(L)
iter=iter+1;
percen=round(iter/(numx/(NFFT/superposicio1))*102)  % Percentatge d'execucio del programa
AA=sxx(i:j);
[Cxy,f] = mscohere(AA,PPP,[],[],[],Fs);  % MSC
Coef(:,iter) = Cxy(1:(NFFT/16));
i=i+NFFT/(superposicio1);
j=j+NFFT/(superposicio1); 
end
jj=1;
while jj<=(iter)                         % Trobar nmaxs
ii=1;
while ii<(nmax1)
[Maxi,Ind]=max(Coef(:,jj));
Maxims(ii,jj)=Maxi;
Coef(Ind,jj)=0;
ii=1+ii;
end
jj=jj+1;
end
t = tempstotal*(1:(iter))/iter;
Mediana=median(Maxims);                 % Mitjana dels nmaxs
f=figure
titlet=sprintf('Mtodes similitud, %s,',patrotitle);
subplot(2,2,1)
plot(t,Mediana);
hgca = gca;
grid on;
if(button==0)
hgca.XTick = (tp1);
else
hgca.XTick = (1.5);
end
hgca.YTick = 0.75;
titlet=sprintf('MSC equivalent');
title(titlet)
ylim([0 1])
xlim([0 tempstotal])
% % % % % ------------------------------ 2- MSC MIG  -----------------------------------------------%
tempstotal=L*((1/fs1));
iter=0;
i=1;
j=finestra+i-1;
tt=0;
NFFT = 2^nextpow2(j-i); 
while j<(L)
iter=iter+1;
percen=round(iter/(numx/(NFFT/superposicio2))*102)
AA=sxx(i:j);
[Cxy2,f] = mscohere(AA,PPP,[],[],[],Fs);
Coef2(:,iter) = Cxy2(1:(NFFT/2));
i=i+NFFT/(superposicio2);
j=j+NFFT/(superposicio2); 
end
jj=1;
while jj<=(iter)                    % Fer la suma i mitjana de tots els MSC
ii=1;
Acumulatjj=0;
while ii<(nmig+1)
Acumulatjj=Acumulatjj+Coef2(ii,jj);
ii=1+ii;
end
Mitjanajj(jj)=(Acumulatjj/nmig);
jj=jj+1;
end
t = tempstotal*(1:(iter))/iter;
subplot(2,2,3)
plot(t,Mitjanajj);
hgca = gca;
grid on;
if(button==0)
hgca.XTick = (tp1);
else
hgca.XTick = (1.5);
end
hgca.YTick =limitmig;
titlet=sprintf('MSC mig');
title(titlet)
ylim([0 1])
xlim([0 tempstotal])
xlabel('Temps (s)')
% % % % % ------------------------------- 3- RD EQUIVALENT  ----------------------------------------%
iter=0;
i=1;
j=finestra+i-1;
NFFT = 2^nextpow2(j-i); 
L = numx;  
tempstotal=L*((1/fs1));
while j<(L)
ssxx=sxx(i:j);
iter=iter+1;
percen=round(iter/(L/(NFFT/superposicio3))*102)
psxx= fft(ssxx,NFFT);                   % FFT
f = linspace(0,1,NFFT/2)*Fs/2;
A=abs(psxx(1:NFFT/2));                  %amplitut single side
AA=(A.^2)/NFFT;                         %Power spectrum
k=1;
l=129;
while k<l                               % Fer la RD per a cada punt FFT de l'audio (AA) i el patro(QQQ)
resta(k,iter)=AA(k)-QQQ(k);             
suma(k,iter)=AA(k)+QQQ(k);
rd(k,iter)=1-(abs(resta(k,iter)/suma(k,iter)));
k=k+1;      
end
i=i+NFFT/(superposicio3);
j=j+NFFT/(superposicio3); 
end
jj=1;
while jj<=(iter) 
ii=1;
while ii<(nmax3)                        % Trobar nmaxs
[Maxi2,Ind]=max(rd(:,jj));
Maxims2(ii,jj)=Maxi2;
rd(Ind,jj)=0;
ii=1+ii;
end
jj=jj+1;
end
Mediana2=median(Maxims2);               % Fer mitjana namxs
t = tempstotal*(1:iter)/iter;
subplot(2,2,2)
plot(t,Mediana2);
hgca = gca;
grid on;
if(button==0)
hgca.XTick = (tp2);
else
hgca.XTick = (1.5);
end
hgca.YTick =0.75;
titlet=sprintf('RD equivalent');
title(titlet)
ylim([0 1])
xlim([0 tempstotal])
% % % % % -------------------------------- 4- RD MIG  ----------------------------------------------%
iter=0;
i=1;
j=finestra+i-1;
NFFT = 2^nextpow2(j-i); 
L = numx;  
tempstotal=L*((1/fs1));
while j<(L)
ssxx=sxx(i:j);
iter=iter+1;
percen=round(iter/(L/(NFFT/superposicio4))*102)
psxx= fft(ssxx,NFFT);
f = linspace(0,1,NFFT/2)*Fs/2;          % FFT
A=abs(psxx(1:NFFT/2));                  % Amplitut single side
AA=(A.^2)/NFFT;                         % Power spectrum
k=1;
l=129;
while k<l                               % Fer la RD per a cada punt FFT de l'audio (AA) i el patro(QQQ)
resta(k,iter)=AA(k)-QQQ(k);
suma(k,iter)=AA(k)+QQQ(k);
relac=(abs(resta(k,iter)/suma(k,iter)));
if(button2==1)                          % Opci d'anivellament
if(or(and(and((k<f2patro),(k>f1patro)),(relac<relaclim)),and(and((k<f4patro),(k>f3patro)),(relac<relaclim))))
  relac=relac*relac;
else if relac>relaclim
  relac=sqrt(relac);
    end
end
else
if(or(or(and(and((k<f2patro),(k>f1patro)),(relac<relaclim)),and(and((k<f4patro),(k>f3patro)),(relac<relaclim))),and(and((k<f6patro),(k>f5patro)),(relac<relaclim))))
  relac=relac*relac;
else if relac>relaclim2
  relac=sqrt(relac);
    end
end    
end
rd(k,iter)=1-relac;
k=k+1;
end
i=i+NFFT/(superposicio4);
j=j+NFFT/(superposicio4); 
end
jj=1;
while jj<=(iter) 
ii=1;
Acumulatjj=0;
while ii<(nmig+1)                       % Calcul mitjana de tots els RD
Acumulatjj=Acumulatjj+rd(ii,jj);
ii=1+ii;
end
Mitjanajj(jj)=(Acumulatjj/nmig);
jj=jj+1;
end
t = tempstotal*(1:iter)/iter;
subplot(2,2,4)
plot(t,Mitjanajj);
hgca = gca;
grid on;
if(button==0)
hgca.XTick = (tp2);
else
hgca.XTick = (1.5);
end
hgca.YTick =limitmig;
titlet=sprintf('RD mig ponderat');
title(titlet)
ylim([0 1])
xlim([0 tempstotal])
xlabel('Temps (s)')

% % % % % ------------------------------------------------------------------------------------------%
% % % % % --------------  TROBAR COMPONENTS FREQUENCIALS AMB MS ENERGIA----------------------------%
% % % % % ------------------------------------------------------------------------------------------%
Matriuespectres = importdata('Matriuespectres_256.txt');  
L=numel(Matriuespectres(:,1));
j=0;
while j<L 
j=j+1;
[Maxi,Ind]=max(Matriuespectres(j,1:129));
Matriuespectres(j,Ind)=0;
[Maxi2,Ind2]=max(Matriuespectres(j,1:129));
Maximafreq(j,1)=Maxi;
Maximafreq(j,3)=Matriuespectres(j,130);
Maximafreq(j,2)=Maxi2;
end
i=1;
Maximafreqq=Maximafreq;
while i<(200)
[Maxim,Ind]=max(Maximafreqq(:,1));
Maxims(i,1)=Maxim;
Maxims(i,2)=Maximafreqq(Ind,2);
Maxims(i,3)=Maximafreqq(Ind,3);
Maximafreqq(Ind,1)=0;
i=1+i;
end

% % % % % ------------------------------------------------------------------------------------------%
% % % % % ------------------------  TROBAR MSC MS ALT ENTRE DOS AUDIOS ----------------------------%
% % % % % ------------------------------------------------------------------------------------------%

% % % % % % ----------------------------  LECTURA  ---------------------------------------------------%
[xx,fs1] = audioread('AudioAccident.wav');  %% 1er accident
sxx=xx(:,1);
[yy,fs1] = audioread('Audio2accident.wav'); %% 2ontaccident
numx=numel(sxx);
syy=yy(:,1);
numy=numel(syy);
if numx<numy;
    while numx<numy;
        numx=numx+1;
        sxx(numx,1)=0;
    end
else
    while numy<numx;
        numy=numy+1;
        syy(numy,1)=0;
    end
end
PP=syy;
Fs = 44100;                  
T = 1/Fs;                     
L = numx;                     
%..............................................................................................................
superposicio=1;
finestra=256*1;
nmax=round(finestra*0.03);
%..............................................................................................................
if nmax<9
    nmax=9;
end
if nmax>20
    nmax=20;
end
tempstotal=L*1/Fs;
iter=0;
itern=0;
r=1;
s=finestra+r;
i=1;
j=finestra+i;
tt=0;
L=L;
NFFT = 2^nextpow2(j-i); % 
while r<(L);    
    itern=itern+1;
    i=1;
    j=finestra+i;
while j<(L)
iter=iter+1
AA=sxx(i:j);
temps1=(1/Fs)*1000+1000*j*1/Fs;
temps1=round(temps1);
[Cxy,f] = mscohere(AA,PP,[],[],[],Fs);
[pks,locs] = findpeaks(Cxy,'MinPeakHeight',0.75);
figure
plot(f,Cxy);
grid on;
hgca = gca;
hgca.XTick = f(locs);
hgca.YTick = .75;
axis([0 15000 0 1]);
titlet=sprintf('Magnitude Square Coherence de 2 audios');
title(titlet);
xlabel('Frequencia (Hz)');
ylabel('Coeficient similitud');
Coef(:,iter) = Cxy(1:(NFFT/16));
i=i+NFFT/(superposicio);
j=j+NFFT/(superposicio); 
end
end

